
#pragma once


namespace SCHook
{
	#define MAX_TEXT_LENGTH 1024

	// ݹ Լ 
	typedef struct _REGISTER_ENTRY
	{

		DWORD _EAX;
		DWORD _EBX;
		DWORD _ECX;
		DWORD _EDX;
		DWORD _ESI;
		DWORD _EDI;
		DWORD _EBP;
		DWORD _ESP;

	} REGISTER_ENTRY, *PREGISTER_ENTRY;

	typedef void (* PROC_HookCallback)(LPVOID pHookedPoint, PREGISTER_ENTRY pRegisters);

	// ̳ʰ ϴ Լ
	typedef HMODULE (__stdcall * PROC_GetCurAlgorithm)();
	typedef HMODULE (__stdcall * PROC_GetCurTranslator)();
	typedef BOOL	(__stdcall * PROC_HookDllFunction)(LPCSTR cszDllName, LPCSTR cszFuncName, LPVOID pfnNewFunc);
	typedef BOOL	(__stdcall * PROC_UnhookDllFunction)(LPCSTR cszDllName, LPCSTR cszFuncName);
	typedef LPVOID	(__stdcall * PROC_GetOrigDllFunction)(LPCSTR cszDllName, LPCSTR cszFuncName);
	typedef BOOL	(__stdcall * PROC_HookCodePoint)(LPVOID pCodePoint, PROC_HookCallback pfnCallback);
	typedef BOOL	(__stdcall * PROC_UnhookCodePoint)(LPVOID pCodePoint);
	typedef BOOL	(__stdcall * PROC_TranslateText)(LPCSTR cszJapanese, LPSTR szKorean, int nBufSize);
	typedef BOOL	(__stdcall * PROC_TranslateText)(LPCSTR cszJapanese, LPSTR szKorean, int nBufSize);
	typedef BOOL	(__stdcall * PROC_IsAppLocaleLoaded)();
	typedef BOOL	(__stdcall * PROC_EnableAppLocale)(BOOL bEnable);

	typedef struct _CONTAINER_FUNCTION_ENTRY
	{

		PROC_GetCurAlgorithm	pfnGetCurAlgorithm;
		PROC_GetCurTranslator	pfnGetCurTranslator;
		PROC_HookDllFunction	pfnHookDllFunction;
		PROC_UnhookDllFunction	pfnUnhookDllFunction;
		PROC_GetOrigDllFunction	pfnGetOrigDllFunction;
		PROC_HookCodePoint		pfnHookCodePoint;
		PROC_UnhookCodePoint	pfnUnhookCodePoint;
		PROC_TranslateText		pfnTranslateText;
		PROC_IsAppLocaleLoaded	pfnIsAppLocaleLoaded;
		PROC_EnableAppLocale	pfnEnableAppLocale;

	} CONTAINER_FUNCTION_ENTRY, *PCONTAINER_FUNCTION_ENTRY;


	// Ʈ  Լ Ʈ
	typedef DWORD (__stdcall * PROC_GetGlyphOutline)(HDC, UINT, UINT, LPGLYPHMETRICS, DWORD, LPVOID, CONST MAT2*);
	typedef BOOL (__stdcall * PROC_TextOut)(HDC, int, int, LPCVOID, int);
	typedef BOOL (__stdcall * PROC_ExtTextOut)(HDC, int, int, UINT, CONST RECT*, LPCVOID, UINT, CONST INT*);
	typedef int (__stdcall * PROC_DrawText)(HDC, LPCVOID, int, LPRECT, UINT);
	typedef int (__stdcall * PROC_DrawTextEx)(HDC, LPCVOID ,int ,LPRECT, UINT, LPDRAWTEXTPARAMS);

	typedef int (__stdcall * PROC_WideCharToMultiByte)(UINT,DWORD,LPCWSTR,int,LPSTR,int,LPCSTR,LPBOOL);
	typedef int (__stdcall * PROC_MultiByteToWideChar)(UINT,DWORD,LPCSTR,int,LPWSTR,int);
	typedef HMODULE (__stdcall * PROC_LoadLibrary)(LPCVOID);

	typedef HFONT (__stdcall * PROC_CreateFontIndirect)(LPVOID lpLogFont);
	typedef HFONT (__stdcall * PROC_CreateFont)(
					 int nHeight,               // height of font
					 int nWidth,                // average character width
					 int nEscapement,           // angle of escapement
					 int nOrientation,          // base-line orientation angle
					 int fnWeight,              // font weight
					 DWORD fdwItalic,           // italic attribute option
					 DWORD fdwUnderline,        // underline attribute option
					 DWORD fdwStrikeOut,        // strikeout attribute option
					 DWORD fdwCharSet,          // character set identifier
					 DWORD fdwOutputPrecision,  // output precision
					 DWORD fdwClipPrecision,    // clipping precision
					 DWORD fdwQuality,          // output quality
					 DWORD fdwPitchAndFamily,   // pitch and family
					 LPVOID lpszFace           // typeface name
					 );

	typedef struct _TEXT_FUNCTION_ENTRY
	{

		PROC_GetGlyphOutline		pfnGetGlyphOutlineA;
		PROC_GetGlyphOutline		pfnGetGlyphOutlineW;
		PROC_TextOut				pfnTextOutA;
		PROC_TextOut				pfnTextOutW;
		PROC_ExtTextOut				pfnExtTextOutA;
		PROC_ExtTextOut				pfnExtTextOutW;
		PROC_WideCharToMultiByte	pfnOrigWideCharToMultiByte;
		PROC_MultiByteToWideChar	pfnOrigMultiByteToWideChar;
		PROC_DrawText				pfnDrawTextA;
		PROC_DrawText				pfnDrawTextW;
		PROC_DrawTextEx				pfnDrawTextExA;
		PROC_DrawTextEx				pfnDrawTextExW;

	} TEXT_FUNCTION_ENTRY, *PTEXT_FUNCTION_ENTRY;


	typedef struct _FONT_FUNCTION_ENTRY
	{

		PROC_CreateFont		pfnCreateFontA;
		PROC_CreateFont		pfnCreateFontW;
		PROC_CreateFontIndirect pfnCreateFontIndirectA;
		PROC_CreateFontIndirect pfnCreateFontIndirectW;

	} FONT_FUNCTION_ENTRY, *PFONT_FUNCTION_ENTRY;

	typedef struct _LIBRARY_FUNCTION_ENTRY
	{
		PROC_LoadLibrary	pfnLoadLibraryA;
		PROC_LoadLibrary	pfnLoadLibraryW;	
	} LIBRARY_FUNCTION_ENTRY, *PLIBRARY_FUNCTUIN_ENTRY;

}