#include "StdAfx.h"
#include "HookAddressData.h"

#include "SCMain.h"
#include "Util.h"


namespace SCHook
{
	CHookAddressData::CHookAddressData(void)
	{
		m_sHookModuleName = "";		// ŷ  ̸
		m_hHookModule = NULL;				// ŷ  ڵ
		m_pHookCodePoint = 0;			// ŷ κ ּ
//		m_pReturnPointCodePoint = 0x0043C463;	// ŷ RPּ
	//	m_lsHookRegisterList;		// ŷ ͸Ʈ
		m_sHookAddress = "";
		m_bNowHookRun = false;
		m_lsHookRegisterList.clear();
	}

	CHookAddressData::CHookAddressData(CString sOptionString)
	{
		m_sHookModuleName = "";		// ŷ  ̸
		m_hHookModule = NULL;				// ŷ  ڵ
		m_pHookCodePoint = 0;			// ŷ κ ּ
//		m_pReturnPointCodePoint = 0x0043C463;	// ŷ RPּ
	//	m_lsHookRegisterList;		// ŷ ͸Ʈ
		m_sHookAddress = "";
		m_bNowHookRun = false;	
		m_lsHookRegisterList.clear();

		SetHookAddressFromOptionString(sOptionString);
	}

	CHookAddressData::CHookAddressData(CString sHookAddress,CString sHookRegister)
	{
		m_sHookModuleName = "";		// ŷ  ̸
		m_hHookModule = NULL;				// ŷ  ڵ
		m_pHookCodePoint = 0;			// ŷ κ ּ
//		m_pReturnPointCodePoint = 0x0043C463;	// ŷ RPּ
	//	m_lsHookRegisterList;		// ŷ ͸Ʈ
		m_sHookAddress = "";
		m_bNowHookRun = false;
		m_lsHookRegisterList.clear();

		SetHookAddress( sHookAddress,sHookRegister );
	}

	CHookAddressData::~CHookAddressData(void)
	{
		EndHooking();
		ClearAllRegisterListAndDelete();
	}

	////////////////////////////////////////////////////
	// ŷּ  ԼԴϴ.
	bool CHookAddressData::SetHookAddress(CString sHookModuleAndAddress)
	{
		if( IsNowHook() == true ) return false;

		CString sModuleName;
		CString sAddress;
		bool bResult = _CuttingModuleAndAddressString(sHookModuleAndAddress,sModuleName,sAddress);
		if( bResult == true )
		{
			bResult = SetHookAddress( sModuleName , sAddress );
		}
		return bResult;
	}

	////////////////////////////////////////////////////
	// ŷּ  ԼԴϴ.
	bool CHookAddressData::SetHookAddress(CString sModuleName,CString sHookAddress)
	{
		if( IsNowHook() == true ) return false;

		m_hHookModule = GetModuleHandle(sModuleName);
		if( m_hHookModule == NULL ) 
		{
			if( sHookAddress == "" ) return false;
			m_sHookModuleName = "";
		}
		else
		{
			m_sHookModuleName = sModuleName;
		}
	//	m_pHookCodePoint.Format(_T("%
		_stscanf(sHookAddress, _T("%x"), &m_pHookCodePoint);
		return true;
	}

	////////////////////////////////////////////////////
	// ŷּ  ԼԴϴ.
	bool CHookAddressData::SetHookAddress(CString sModuleName,CString sHookAddress,CString sHookRegister)
	{
		if( IsNowHook() == true ) return false;

		bool bResult = SetHookAddress(sModuleName,sHookAddress);
		if( bResult == true )
		{
			/*bResult = */AddHookRegisterData(sHookRegister);
		}
		return bResult;
	}

	////////////////////////////////////////////////////
	// AddressOptionString Address
	//--------------------------------------------
	// - 忡 Module HookAddress ϰ Register(TRANS) ؼ Register Ѵ.
	// -  ׻ Module HookAddress αѴ. 
	bool CHookAddressData::SetHookAddressFromOptionString(CString sOptionString)
	{
		if( IsNowHook() == true ) return false;

		CString sBufString = sOptionString;
		CString sLeftString;

		// REG & OFFSET    ó , 
		int nHKADDEndIndex = sBufString.Find(',');
		CString sModuleAddressString;
		if( nHKADDEndIndex > 0 )
		{
			sModuleAddressString = sBufString.Left(nHKADDEndIndex);
			sLeftString = sBufString.Mid(nHKADDEndIndex + 1);
		}
		else
		{
			sModuleAddressString = sBufString;
			sLeftString = _T("");
		}	//  ڿ з۾Դϴ.
		// MA 
		if( sModuleAddressString != _T("") )
		{
			if( SetHookAddress(sModuleAddressString) == false )
			{
				return false;
			}
		}
		sBufString = sLeftString;

		while( sBufString != _T("") ) 
		{
			//  ߰
			CHookRegisterData *pNewReg = new CHookRegisterData();
			if( pNewReg->SettingRegisterData(sBufString) == false )
			{
				delete pNewReg;
				pNewReg = NULL;
				break;
			}
			if( AddHookRegisterData(pNewReg) == false )
			{
				delete pNewReg;
				pNewReg = NULL;
			}
		}

		return true;
	}

	////////////////////////////////////////////////////
	// ŷּҸ ϰ  Ʋ   Ʋ ش.
	bool CHookAddressData::SettingAddressData(CString &sDataString)
	{
		if( IsNowHook() == true ) return false;

		CString sLeftString;			//  Ʋ  
		CString sOptionString;			// س ɼ Ʋ
	//	if( _FindRegisterOptionString(sDataString,sOptionString,sLeftString) == false ) return false;	// 
		if( CUtil::ExtractString(sDataString,_T("HOOK"),sOptionString,sLeftString) == false ) return false;	// 
	//	MessageBox(NULL,sOptionString,_T("CHookAddressData::SettingAddressData"),MB_OK);
		if( SetHookAddressFromOptionString(sOptionString) == false ) return false;						// 
		sDataString = sLeftString;																		// ϰ  Ʋ
		return true;																					// 

	}



	////////////////////////////////////////////////////
	// ŷ  ߰.( ϰ ŵǾ .)
	bool CHookAddressData::AddHookRegisterData(CString sDataString)
	{
		if( IsNowHook() == true ) return false;

		bool bResult = true;
		CString sStringTemp = sDataString;
		while( true )
		{
			if( sStringTemp == "" ) break;										//  Ʋ  
			
			CHookRegisterData* pHookRegData = new CHookRegisterData();			// ο Ʈ ϰ
	//		MessageBox(NULL,sStringTemp,_T("CHookRegisterData"),MB_OK);
			if( pHookRegData->SettingRegisterData( sStringTemp ) == false )		// Ѵ.
			{
				bResult = false;												//  ϸ
				delete pHookRegData;											// 
				break;															// и 
			}

			if( AddHookRegisterData(pHookRegData) == false )					// ϸ ߰Ѵ.
			{
				delete pHookRegData;											//  .
			}		
			// ׸  Ʋ ٽ õ.
		}
		return bResult;
	}

	////////////////////////////////////////////////////
	// ŷ  ߰.( ϰ ŵǾ .)
	bool CHookAddressData::AddHookRegisterData(CHookRegisterData* pHookRegData)
	{
		if( IsNowHook() == true ) return false;

		bool bResult = true;
		// ߺ  ִ ˻.
		for( list<CHookRegisterData*>::iterator iter_phkRegCur = m_lsHookRegisterList.begin();
			iter_phkRegCur != m_lsHookRegisterList.end();
			iter_phkRegCur++ )
		{
			if( (*iter_phkRegCur)->IsMatch(*pHookRegData) == true )
			{
				bResult = false;	//  false
				break;
			}
		}
		
		if( bResult == true )		//  ߰
		{
			m_lsHookRegisterList.push_back(pHookRegData);
		}

		return bResult;	
	}

	////////////////////////////////////////////////////
	// ŷ  ߰.( ϰ ŵǾ .)
	bool CHookAddressData::AddHookRegisterDataFromAddressData(CHookAddressData* pHookAddressData)
	{
		if( IsNowHook() == true ) return false;

		bool bResult = false;
	//	if( pHookAddressData->m_lsHookRegisterList.size() == 0 ) return false;			//  ٸ.
		while(true)
		{
			if( pHookAddressData->m_lsHookRegisterList.size() == 0 )
			{
				break;			//  ٸ.
			}
			CHookRegisterData* pRegdat = pHookAddressData->m_lsHookRegisterList.front();
			if( pRegdat == NULL )
			{
				break;
			}
			m_lsHookRegisterList.remove(pRegdat);
			if( AddHookRegisterData(pRegdat) == true )
			{
				bResult = true;
			}
		}
		return bResult;
	//	if( pHookAddressData->m_lsHookRegisterList.size() > 0 ) return  ;			// µ ?
	//	else return true;
	}

	//############################################################################
	/*
	////////////////////////////////////////////////////
	// ŷ   ɴϴ.
	CHookRegisterData* CHookAddressData::GetHookRegisterData(int nIndex)
	{d
		int nSize = GetHookRegisterListLength();
		if( nIndex < 0 ||  nIndex >= nSize ) return NULL;
	//	m_lsHookRegisterList.
		return (m_lsHookRegisterList[nIndex]);	
	}
	*/

	////////////////////////////////////////////////////
	// ŷ  .
	int	CHookAddressData::GetHookRegisterListLength()
	{
		if( IsNowHook() == true ) return false;

		list<CHookRegisterData*>::size_type nlength = m_lsHookRegisterList.size();
		return nlength;
	}


	//############################################################################
	// 

	////////////////////////////////////////////////////
	//  ͸   ʴ´.
	bool CHookAddressData::ClearAllRegisterListAndNoDelete()
	{
		if( IsNowHook() == true ) return false;

		m_lsHookRegisterList.clear();
		return false;
	}

	////////////////////////////////////////////////////
	//  ͸  Ѵ.
	bool CHookAddressData::ClearAllRegisterListAndDelete()
	{
		if( IsNowHook() == true ) return false;

		while(true)
		{
			if( m_lsHookRegisterList.size() == 0 ) return true;			// µ ?
			CHookRegisterData* pRegData = m_lsHookRegisterList.front();		
			if( pRegData == NULL )									//  
			{
				break;
			}
			m_lsHookRegisterList.remove(pRegData);					// Ʈ ϰ	
			delete pRegData;										// ޸𸮿 .
		}
		if( m_lsHookRegisterList.size() > 0 ) return false;			// µ ?
		else return true;
	}

	//############################################################################

	////////////////////////////////////////////////////
	//  ּ Ʋ ȯմϴ.
	CString CHookAddressData::GetHookModuleAndAddressString()
	{
		CString strRetVal;

		if(NULL == m_hHookModule)								//  .(α׷⺻.)
		{
			strRetVal.Format(_T("0x%p"), m_pHookCodePoint);
		}
		else													//  .
		{
			strRetVal.Format(_T("%s!0x%p"), (LPCTSTR)m_sHookModuleName, m_pHookCodePoint);
		}
		
		return strRetVal;
	}

	////////////////////////////////////////////////////
	// ŷּҸ ɴϴ.
	UINT_PTR CHookAddressData::GetHookAddress()
	{
		return ( (UINT_PTR)m_hHookModule + m_pHookCodePoint );
	}

	//###########################################################################
	// ܺζ 

	////////////////////////////////////////////////////
	// ƮƮѿ Ѵ.
	bool CHookAddressData::ApplyListControlFromHookData(int &nRowNumber ,CListCtrl &lsctlHookAddressList)
	{
		CString sHMAString = GetHookModuleAndAddressString();

		if( lsctlHookAddressList.InsertItem(nRowNumber,sHMAString) >= 0)
	//	if( lsctlHookAddressList.SetItem(nRowNumber,0,LVIF_TEXT,sHMAString,0,0,0,0) == TRUE )
		{
			bool bRegInput = false;
			for( list<CHookRegisterData*>::iterator iter_pHKRegCur = m_lsHookRegisterList.begin();
				iter_pHKRegCur != m_lsHookRegisterList.end();
				iter_pHKRegCur ++ )
			{
				(*iter_pHKRegCur)->ApplyListControlFromHookData(nRowNumber,lsctlHookAddressList);
				bRegInput = true;
				nRowNumber ++;
			}
			
			if( bRegInput == false)
			{
				nRowNumber ++;
			}

			return true;
		}

		return false;
	}

	//////////////////////////////////////////////////////
	//  Ʋȭ Ѽ ´.
	CString CHookAddressData::GetDataToString()
	{
		CString sOptionString = _T("");

		sOptionString += GetHookModuleAndAddressString();
		
		// ɼǷƮ 
		for( list<CHookRegisterData*>::iterator iter_pHKRegCur = m_lsHookRegisterList.begin();
			iter_pHKRegCur != m_lsHookRegisterList.end();
			iter_pHKRegCur ++ )
		{
			CString sRegOptionString = (*iter_pHKRegCur)->GetDataToString();
			if( sRegOptionString != _T("") )
			{
				if( sOptionString != _T("") )
				{
					sOptionString += _T(",");
				}
				sOptionString += sRegOptionString;
			}
		}

		// ׿ ɼ  ( )


		if( sOptionString != _T("") )
		{
			sOptionString = _T("HOOK(") + sOptionString + _T(")");
		}

		return sOptionString;
	}

	//###########################################################################

	////////////////////////////////////////////////////
	// ŷ մϴ.
	bool CHookAddressData::StartHooking()
	{
		//  ŷ  ˴ϴ
		if( m_bNowHookRun == true ) return false;

		// ŷ
		if( CSCMain::GetInstance()->HookCodePoint(GetHookAddress()) == true )
		{
			//  ͵ 鼭 RP  RP ŷ Ѵ.
			for( list<CHookRegisterData*>::iterator iter_pHKRegCur = m_lsHookRegisterList.begin();
				iter_pHKRegCur != m_lsHookRegisterList.end();
				iter_pHKRegCur ++ )
			{
				// ̹ Ͱ RP Ѵٸ
				if( (*iter_pHKRegCur)->IsUseReturnPoint() == true )
				{
					// RPּҸ ͼ
					UINT_PTR pRPAddress = (*iter_pHKRegCur)->GetRPPoint();
					if( pRPAddress != 0 ) 
					{
						// RP ŷ Ѵ.
						CSCMain::GetInstance()->HookCodePoint( (UINT_PTR)m_hHookModule + pRPAddress );							
					}
				}
				
			}
			return true;
		}
		return false;
	}

	////////////////////////////////////////////////////
	// ŷ մϴ.
	bool CHookAddressData::EndHooking()
	{
		if( m_bNowHookRun == false ) return false;

		if( CSCMain::GetInstance()->UnhookCodePoint(GetHookAddress()) == true )
		{
			//  ͵ 鼭 RP  RP ŷ Ѵ.
			for( list<CHookRegisterData*>::iterator iter_pHKRegCur = m_lsHookRegisterList.begin();
				iter_pHKRegCur != m_lsHookRegisterList.end();
				iter_pHKRegCur ++ )
			{
				// ̹ Ͱ RP Ѵٸ
				if( (*iter_pHKRegCur)->IsUseReturnPoint() == true )
				{
					// RPּҸ ͼ
					UINT_PTR pRPAddress = (*iter_pHKRegCur)->GetRPPoint();
					if( pRPAddress != 0 ) 
					{
						// RP ŷ Ѵ.
						CSCMain::GetInstance()->UnhookCodePoint( (UINT_PTR)m_hHookModule + pRPAddress );							
					}
				}
				
			}
			m_bNowHookRun = false;
			return true;
		}
		return false;
	}

	////////////////////////////////////////////////////
	//   ּҰ ŷ Ÿϴ.
	bool CHookAddressData::IsNowHook()
	{
		return m_bNowHookRun;
	}

	////////////////////////////////////////////////////
	// ־ Ѵ.
	bool CHookAddressData::ExecuteCmd(PREGISTER_ENTRY pRegisters,UINT_PTR pCodePoint)
	{
		bool bResult = false;
		if( pCodePoint == 0 ) 
		{
			
			for( list<CHookRegisterData*>::iterator iter_pHKRegCur = m_lsHookRegisterList.begin();
				iter_pHKRegCur != m_lsHookRegisterList.end();
				iter_pHKRegCur ++ )
			{
				if( (*iter_pHKRegCur)->ExecuteCmd(pRegisters) == true )
				{
					bResult = true;
				}
			}
			
		}
		else
		{
			// Address  Call ȣߴ Ȥ
			if( pCodePoint == GetHookAddress() )
			{	// 
				return ExecuteCmd( pRegisters );
			}

			// Register RP Call ȮѴ.
			for( list<CHookRegisterData*>::iterator iter_pHKRegCur = m_lsHookRegisterList.begin();
				iter_pHKRegCur != m_lsHookRegisterList.end();
				iter_pHKRegCur ++ )
			{
				UINT_PTR pRPTemp = 0;
				pRPTemp = (*iter_pHKRegCur)->GetRPPoint() + (UINT_PTR)m_hHookModule;

				if( pRPTemp == pCodePoint ) // RPּҰ ´ٸ
				{
					if( (*iter_pHKRegCur)->ExecuteCmd(pRegisters,1) == true )
					{
						bResult = true;
					}
				}
				
			}
		}
		return bResult;
	}

	//###########################################################################

	////////////////////////////////////////////////////
	// ⽺Ʋ ּ Ʋ ϴ.
	bool CHookAddressData::_CuttingModuleAndAddressString(CString sOriginalString,CString &sModuleName,CString &sHookAddress)
	{
		int nIdx = sOriginalString.ReverseFind(_T('!'));
		
		sModuleName = "";
		sHookAddress = "";

		if(nIdx>=0)
		{
			sModuleName = sOriginalString.Left(nIdx);
			sHookAddress = sOriginalString.Mid(nIdx+1);
	//		_stscanf(strAddr.Mid(nIdx+1), _T("%x"), &pInst->m_pCodePoint);
		}
		else
		{
			sHookAddress = sOriginalString;
		}
		sHookAddress = CUtil::FormatAddress(sHookAddress);

		if( sModuleName == "" && sHookAddress == "" ) return false;
		return true;
	}
}