#pragma once


#include <map>
#include <list>
#include "SCBase.h"

using namespace std;


namespace SCNode
{

	// Base					00000001
	// SCPtr				00000002
	// SCData				00000004
	// SCChar				00000008

	// SCString				00000010
	// SCStruct				00000020
	// SCLinkListNode		00000040
	// SCLinkListStartPtr	00000080

	// SCLinkListPrevPtr	00000100
	// SCLinkListNextPtr	00000200
	// SCLinkListEndPtr		00000400
	// SCUnknown			00000800

	// SCArrangeNode		00001000
	// SCArrangeStartPtr	00002000



	enum ESCNodeUseIntentionList
	{
		//  뵵
		UnknownIntention = 0,
		
		//-----------------------------
		// Ʋ 뵵
		Ptr_UseString,
		Ptr_UseStruct,
		// ũƮÿ뵵
		Ptr_UseLinkListStartAddress,
		Ptr_UseLinkListEndAddress,
		Ptr_UseLinkListNextAddress,
		Ptr_UseLinkListPrevAddress,
		// 迭 ÿ뵵
		Ptr_UseArrangeStartAddress,
		Ptr_UseArrangeEndAddress,
		
		//------------------------------
		//  Ÿ 뵵 ´°.
		Data_UseChar,
		Data_UseLinkListNodeCount,
		Data_UseArrangeCount,


	};

	// SCNode鿡 ؼ ̰   Լ.
	// ̰ Static ұ? ƴϸ ̱?
	// ƴϸ ڸ װ CHookRegister Ŭ ֵ ұ?
	class CSCNodeMgr
	{
	friend class CSCMgr;		//  Ŭ  CSCMgr ϰ ϱ ؼ ̴.
	protected:
		//   .
		map<HTREEITEM,CSCBase*>	m_mapSCMatchTree;
		CSCBase* m_pSCRootNode;

		DWORD pOriginalRegValue;
		DWORD pFakeRegValue;

		list<void*> m_OriginalTemp;						// LastTrans ϱ   (PtrChangeκ   صд.)
		list<void*> m_FakeTemp;							// FakeData 
		list<void*> m_SaveLoseJobOriginalValue;			// ptrChange Ҿڸ   (    .
		list<void*> m_SaveLostJobFakeValue;				// RPĿ LoseJobOriginalValue ٲܶ ̰ ä.
														//  ٽ Fake ٲٰ  ̰ .
		
		list<CString> m_lsstrLastJpString;				// Getting ڿ ̰Ŷ ٸ. LastKrString ٲش.(_ReTransFakeStruct)
		list<CString> m_lsstrLastKrString;				// Getting ڿ Kr ٸ Trans ʴ´.

	protected:
		CSCNodeMgr(void);
	public:
		~CSCNodeMgr(void);

		// 
		bool SetSCRootNode(CSCBase* pRootNode);			// Ŀ  ۼ SCNode Ѵ.( õ   Ϻ   ѱ   ̷.)


		
		// SCNode   Լ
		// ̰͵  Static??
		CSCBase* CreateSCNode(ESCNodeUseIntentionList eWhatForUse,CSCBase* pParentNode = NULL);
																	// SCNode . (CSCNode class ƴϴ.)
		bool DestroySCNode(CSCBase* pDestroyNode);					// 带 . (ڽĵ )
		bool CuttingNode(CSCBase* pCuttingNode);					//  带 ü  Ʈ ߶󳽴.


		// 
		void SetOriginalReg(DWORD pOriginalRegValue);				//  Ͱ̴.
		void GetFakeReg(DWORD pFakeRegValue);						// ¥ Ͱ̴(Trans۾ (Originalϰ ִ.

		bool IsFakeData();											// õǾִ OriginalRegValue ȮѴ.
																	// PtrChange Ptr m_FakeTemp ִ Ȯϸȴ.
		bool IsLastTrans();											// õǾִ OriginalRegValue ȮѴ.
																	// ѹ Ǿִ Ȯϴ ۾ Ǿٸ _ReTrans ؼ ۾  ʴ´.

		bool ExtractJpString();										// JpƲ Ѵ.
		bool GettingJpString(list<CString> sJpString);				//  JpƲ ´.
		bool SettingKrString(list<CString> sKrString);				//  krƲ Ѵ.	(̰ ؾ GetFakeReg Ҽִ.?)
		
	protected:
		bool _ReTransFakeStruct();									// ѹ ۾ ̱⶧  ۾޴  ٲش.
	};
}