#include "StdAfx.h"
#include "SCMain.h"

#include "OptionDlg.h"
#include "Util.h"
#include "RegistryMgr\\cRegistryMgr.h"


namespace SCHook
{
	//////////////////////////////////////////////////////////////////////////////
	// ###########################################################################
	CSCMain* CSCMain::ms_pInstance = NULL;

	/////////////////////////////////////////////////////////////////
	// CSCMain 
	bool CSCMain::InitInstance()
	{
		if( ms_pInstance != NULL ) return false;	//  ȵѵ~
		ms_pInstance = new CSCMain();
		return true;
	}

	/////////////////////////////////////////////////////////////////
	// CSCMain ٱ
	CSCMain* CSCMain::GetInstance()
	{
		return ms_pInstance;
	}

	/////////////////////////////////////////////////////////////////
	// CSCMain 
	bool CSCMain::CloseInstance()
	{
		if( ms_pInstance == NULL ) return false;	//   ؿ~
		delete ms_pInstance;
		ms_pInstance = NULL;
		return true;	
	}
	// ###########################################################################
	//////////////////////////////////////////////////////////////////////////////

	CSCMain::CSCMain(void)
	{
		m_hParentWnd = NULL;			// θ handle
		m_hContainer = NULL;			// "ATCTNR.DLL"
		ZeroMemory(&m_sContainerFunc, sizeof(CONTAINER_FUNCTION_ENTRY));
		ZeroMemory(&m_sTextFunc, sizeof(TEXT_FUNCTION_ENTRY));
		ZeroMemory(&m_sFontFunc, sizeof(FONT_FUNCTION_ENTRY	));		
		ZeroMemory(&m_sLibraryFunc, sizeof(LIBRARY_FUNCTION_ENTRY));
		m_szOptionString = NULL;

		m_bRunning = false;
		m_sLastFontFace = "";

	//	m_lsHookAddressList;			// ŷϴ 巹 Ʈ
		m_bAllHookingSuccess = false;
		m_bChangeHookData = false;		// ŷϴ Ÿ  ŵǾ Ÿ.


		m_nFontLoadLevel = 0;				// Ʈ  ε 
		m_nFontSize = 0;					// Ʈ 
		m_sFontFace = "";					// Ʈ
		m_bFixedFontSize = false;				// Ʈ  
		m_bEncodeKorean = false;				// ѱ Ϻ ȯ

	}

	CSCMain::~CSCMain(void)
	{
		
		Close();
	//	m_lsHookAddressList.
	}

	//////////////////////////////////////////////////////////////////
	// plugin ʱȭ
	BOOL CSCMain::Init(HWND hSettingWnd, LPSTR cszOptionStringBuffer)
	{
		// θ  ڵ 
		if(hSettingWnd == NULL) return FALSE;
		m_hParentWnd = hSettingWnd;


		if( _InitContanerFunction() == false ) 		// ̳ Լ ʱȭմϴ.
		{
			// 
			MessageBox( NULL, _T("Ŀ̳ Լ ʱȭϴµ Ͽϴ. ATCTNR.DLL Ȯϼ ") , _T("SCPlugin_Init"),MB_OK); 
			return FALSE;
		}
		if( _InitFontFunction() == false )			// Ʈ Լ ʱȭմϴ.
		{
			MessageBox( NULL, _T("ƮԼ ʱȭϴµ Ͽϴ.") , _T("SCPlugin_Init"),MB_OK); 
		}

		if( _InitLibraryFunction() == false )			// ̺귯 Լ ʱȭմϴ.
		{
			MessageBox( NULL, _T("̺귯 Լ ʱȭ Ͽϴ.") , _T("SCPlugin_Init"),MB_OK); 
		}
		if( _InitTextFunction() == false )			// ؽƮ Լ ʱȭմϴ.
		{
			MessageBox( NULL, _T("ؽƮ Լ ʱȭ Ͽϴ.") , _T("SCPlugin_Init"),MB_OK); 
		}

		// ɼ Ʈ Ľ
		m_szOptionString = cszOptionStringBuffer;

		if(m_szOptionString == NULL)
		{
			m_szOptionString = new char[4096];
			ZeroMemory(m_szOptionString, 4096);
		}
		else
		{
			wchar_t sTemp[4096];
			ZeroMemory(sTemp, 4096);
			CUtil::MyMultiByteToWideChar(949, 0, m_szOptionString, -1,sTemp , 4096);

			if( SetHookOptionString( sTemp ) == true )
			{
				StartHooking();
			}
		}
		//#######################
		//   ƿ~
		//#######################

		return TRUE;
	}


	///////////////////////////////////////////////////////////////////
	// plugin .
	BOOL CSCMain::Close()
	{
//		if( m_hParentWnd == NULL ) return FALSE;
		EndHooking();

		m_hParentWnd = NULL;

		ClearAllAddressListAndDelete();

		_UnhookTextFunction();
		_UnhookLibraryFunction();
		_UnhookFontFunction();

		return TRUE;
	}

	//////////////////////////////////////////////////////////////////
	// plugin (Ŀμ)
	BOOL CSCMain::Start()
	{
		m_bRunning = true;
//		StartHooking();
		return TRUE;
	}

	//////////////////////////////////////////////////////////////////
	// plugin (Ŀμ)
	BOOL CSCMain::Stop()
	{
		m_bRunning = false;
//		EndHooking();
		return TRUE;
	}

	//////////////////////////////////////////////////////////////////
	// plugin ɼâ 
	BOOL CSCMain::Option()
	{
		if( m_hParentWnd == NULL ) return FALSE;

		m_bRunning = false;

		// ŷ 
		EndHooking();

		COptionDlg opdlg;
		if( opdlg.DoModal() == IDOK )
		{
			// opdlg   ɼ ͼ 
			//  ̸
			CString sOptionString = GetHookOptionString();

#ifdef UNICODE
			CUtil::MyWideCharToMultiByte(949, 0, (LPCWSTR)sOptionString, -1, m_szOptionString, 4096, NULL, NULL);
#else
			strcpy(m_szOptionString, (LPCTSTR)sOptionString);
#endif
		}

		// ٽ ŷ .
		StartHooking();

		m_bRunning = true;

		return TRUE;
	}


	//####################################################################################


	/////////////////////////////////////////////////////////////////
	// ŷ 
	bool CSCMain::StartHooking()									
	{
		int nFaildHook = 0;
		for( list<CHookAddressData*>::iterator iter_pHKAddCur = m_lsHookAddressList.begin() ;
			iter_pHKAddCur != m_lsHookAddressList.end() ;
			iter_pHKAddCur ++ )
		{
			if( (*iter_pHKAddCur)->IsNowHook() == false )
			{
				if( (*iter_pHKAddCur)->StartHooking() == false)		// ŷ Ѵ.
				{
					nFaildHook++;
				}
			}
		}
		if( nFaildHook == 0 ) m_bAllHookingSuccess = true;
		else m_bAllHookingSuccess = false;
		m_bRunning = true;

		return true;
	}

	/////////////////////////////////////////////////////////////////
	// ŷ 
	bool CSCMain::EndHooking()											
	{
		for( list<CHookAddressData*>::iterator iter_pHKAddCur = m_lsHookAddressList.begin() ;
			iter_pHKAddCur != m_lsHookAddressList.end() ;
			iter_pHKAddCur ++ )
		{
			(*iter_pHKAddCur)->EndHooking();		// ŷ Ѵ.
		}
		m_bAllHookingSuccess = false;
		m_bRunning = false;
		return true;
	}

	/////////////////////////////////////////////////////////////////
	// ŷ Ѵ.
	bool CSCMain::HookCodePoint(UINT_PTR pCodePoint)					
	{
		// ŷ Լ غ
		if( m_sContainerFunc.pfnHookCodePoint == NULL ) return false;

		PROC_HookCodePoint HookCodePoint = m_sContainerFunc.pfnHookCodePoint;
		if(HookCodePoint == NULL) return false;

		// ŷ
		BOOL bHookRes = HookCodePoint((LPVOID)pCodePoint, HookCodeCallback);
		if(bHookRes == FALSE) return false;

//		CString sMessage;
//		sMessage.Format(_T("Start Hook %x"),pCodePoint);

//		MessageBox(NULL,sMessage,_T("CSCMain"),MB_OK);
		return true;
	}

	/////////////////////////////////////////////////////////////////
	// ũѴ.
	bool CSCMain::UnhookCodePoint(UINT_PTR pCodePoint)
	{
		if( m_sContainerFunc.pfnUnhookCodePoint == NULL ) return false;

		PROC_UnhookCodePoint UnhookCodePoint = m_sContainerFunc.pfnUnhookCodePoint;
		if( UnhookCodePoint == NULL ) return false;

		BOOL bResult = UnhookCodePoint( (LPVOID)pCodePoint );
		if( bResult == FALSE ) return false;
//		CString sMessage;
//		sMessage.Format(_T("End Hook %x"),pCodePoint);

//		MessageBox(NULL,sMessage,_T("CSCMain"),MB_OK);
		return true;	
	}

	/////////////////////////////////////////////////////////////////
	// ŷǾ.
	bool CSCMain::Hooking(UINT_PTR pHookedPoint, PREGISTER_ENTRY pRegisters)
	{
		if( m_bRunning == false ) return false;
		for( list<CHookAddressData*>::iterator iter_pHKAddCur = m_lsHookAddressList.begin() ;
			iter_pHKAddCur != m_lsHookAddressList.end() ;
			iter_pHKAddCur ++ )
		{
			(*iter_pHKAddCur)->ExecuteCmd(pRegisters,pHookedPoint);
//			if( (*iter_pHKAddCur)->GetHookAddress() == pHookedPoint )	// ŷ ã
//			{
//				return (*iter_pHKAddCur)->ExecuteCmd(pRegisters);		//   Ѵ.
//			}
		}
		return true;
	}

	/////////////////////////////////////////////////////////////////
	bool CSCMain::TranslateText(LPCSTR cszJapanese, LPSTR szKorean, int nBufSize)
	{
		PROC_TranslateText pfnTransJ2K = m_sContainerFunc.pfnTranslateText;
		if( pfnTransJ2K == NULL ) return false;

		if( pfnTransJ2K(cszJapanese, szKorean, nBufSize ) == FALSE )
		{
			// 
			return false;
		}

		//



		return true;
	}

	/////////////////////////////////////////////////////////////////
	// Ŀ  Ÿ.
	bool CSCMain::IsRunningHooker()
	{
		return m_bRunning;
	}
	//####################################################################################
	//

	/////////////////////////////////////////////////////////////////
	//
	HFONT CSCMain::CheckFont( HDC hdc )
	{
		HFONT hRetVal = NULL;

		TEXTMETRIC tm;
		BOOL bRes = GetTextMetrics(hdc, &tm);

		// Ʈ ٽ ε
		if( bRes )//&& tm.tmHeight != lLastFontHeight )
		{
			
			HFONT font = NULL;
			long lFontSize = tm.tmHeight;
			
			if( m_sFontFace == "" )
			{
				m_sFontFace = _T("ü");
			}

			// Ʈ̽ ٲ  ʱȭ
			_FontMapClear(m_sFontFace);
			
			// Ʈ ũ  
			if(m_nFontSize !=0 && m_bFixedFontSize)
			{
				lFontSize = m_nFontSize;
			}

			//  ũ⿡ شϴ Ʈ   Ʈ 
			if( m_mapFonts.find(lFontSize) == m_mapFonts.end() )
			{
				font = CreateFont(lFontSize, 0, 0, 0, tm.tmWeight, tm.tmItalic, tm.tmUnderlined, tm.tmStruckOut,
					HANGEUL_CHARSET,	//ANSI_CHARSET,
					OUT_DEFAULT_PRECIS,
					CLIP_DEFAULT_PRECIS,
					ANTIALIASED_QUALITY,
					DEFAULT_PITCH,		// | FF_SWISS,
					m_sFontFace);

				m_mapFonts[lFontSize] = font;

			}
			else
			{
				font = m_mapFonts[lFontSize];
			}

			hRetVal = (HFONT)SelectObject(hdc, font);

		}


		return hRetVal;
	}


	//####################################################################################

	bool CSCMain::_InitContanerFunction()
	{
		// ̳ Լ  
		m_hContainer = GetModuleHandle(_T("ATCTNR.DLL"));
		if( m_hContainer != NULL )
		{
			m_sContainerFunc.pfnGetCurAlgorithm		= (PROC_GetCurAlgorithm) GetProcAddress( m_hContainer, "GetCurAlgorithm" );
			m_sContainerFunc.pfnGetCurTranslator	= (PROC_GetCurTranslator) GetProcAddress( m_hContainer, "GetCurTranslator" );
			m_sContainerFunc.pfnHookDllFunction		= (PROC_HookDllFunction) GetProcAddress( m_hContainer, "HookDllFunction" );
			m_sContainerFunc.pfnGetOrigDllFunction	= (PROC_GetOrigDllFunction) GetProcAddress( m_hContainer, "GetOrigDllFunction" );
			m_sContainerFunc.pfnUnhookDllFunction	= (PROC_UnhookDllFunction) GetProcAddress( m_hContainer, "UnhookDllFunction" );
			m_sContainerFunc.pfnHookCodePoint		= (PROC_HookCodePoint) GetProcAddress( m_hContainer, "HookCodePoint" );
			m_sContainerFunc.pfnUnhookCodePoint		= (PROC_UnhookCodePoint) GetProcAddress( m_hContainer, "UnhookCodePoint" );
			m_sContainerFunc.pfnTranslateText		= (PROC_TranslateText) GetProcAddress( m_hContainer, "TranslateText" );
			m_sContainerFunc.pfnIsAppLocaleLoaded	= (PROC_IsAppLocaleLoaded) GetProcAddress( m_hContainer, "IsAppLocaleLoaded" );
			m_sContainerFunc.pfnEnableAppLocale		= (PROC_EnableAppLocale) GetProcAddress( m_hContainer, "EnableAppLocale" );

			return true;
		}

		return false;
	}

	bool CSCMain::_InitFontFunction()
	{		
		if( m_sContainerFunc.pfnHookDllFunction == NULL ) return false;
		if( m_sContainerFunc.pfnGetOrigDllFunction == NULL ) return false;

		
		// Ʈ Լ ŷ
		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.dll", "CreateFontA", CUtil::NewCreateFontA ) )
		{
			m_sFontFunc.pfnCreateFontA = (PROC_CreateFont) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.dll", "CreateFontA");
		}

		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.dll", "CreateFontW", CUtil::NewCreateFontW ) )
		{
			m_sFontFunc.pfnCreateFontW = (PROC_CreateFont) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.dll", "CreateFontW");
		}

		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.dll", "CreateFontIndirectA", CUtil::NewCreateFontIndirectA ) )
		{
			m_sFontFunc.pfnCreateFontIndirectA = (PROC_CreateFontIndirect) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.dll", "CreateFontIndirectA");
		}

		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.dll", "CreateFontIndirectW", CUtil::NewCreateFontIndirectW ) )
		{
			m_sFontFunc.pfnCreateFontIndirectW = (PROC_CreateFontIndirect) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.dll", "CreateFontIndirectW");
		}

		return true;
	}

	bool CSCMain::_InitLibraryFunction()
	{
		if( m_sContainerFunc.pfnHookDllFunction == NULL ) return false;
		if( m_sContainerFunc.pfnGetOrigDllFunction == NULL ) return false;

		// LoadLibrary Լ ŷ	 
		if( m_sContainerFunc.pfnHookDllFunction( "kernel32.dll", "LoadLibraryA", CUtil::NewLoadLibraryA ) )
		{
			m_sLibraryFunc.pfnLoadLibraryA = (PROC_LoadLibrary) m_sContainerFunc.pfnGetOrigDllFunction("kernel32.dll", "LoadLibraryA");
		}

		if( m_sContainerFunc.pfnHookDllFunction( "kernel32.dll", "LoadLibraryW", CUtil::NewLoadLibraryW ) )
		{
			m_sLibraryFunc.pfnLoadLibraryW = (PROC_LoadLibrary) m_sContainerFunc.pfnGetOrigDllFunction("kernel32.dll", "LoadLibraryW");
		}	

		return true;
	}

	/////////////////////////////////////////////////////////////////
	// ؽƮԼ ʱȭմϴ.
	bool CSCMain::_InitTextFunction()
	{
		if( m_sContainerFunc.pfnGetOrigDllFunction == NULL ) return false;
		if( m_sContainerFunc.pfnHookDllFunction == NULL ) return false;

		// ؽƮ Լ ŷ
		// GetGlyphOutlineA
		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.DLL", "GetGlyphOutlineA", CUtil::NewGetGlyphOutlineA ) )
		{
			m_sTextFunc.pfnGetGlyphOutlineA = 
				(PROC_GetGlyphOutline) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.DLL", "GetGlyphOutlineA");
		}

		// GetGlyphOutlineW
		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.DLL", "GetGlyphOutlineW", CUtil::NewGetGlyphOutlineW ) )
		{
			m_sTextFunc.pfnGetGlyphOutlineW = 
				(PROC_GetGlyphOutline) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.DLL", "GetGlyphOutlineW");
		}

		// TextOutA
		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.DLL", "TextOutA", CUtil::NewTextOutA ) )
		{
			m_sTextFunc.pfnTextOutA = 
				(PROC_TextOut) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.DLL", "TextOutA");
		}

		// TextOutW
		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.DLL", "TextOutW", CUtil::NewTextOutW ) )
		{
			m_sTextFunc.pfnTextOutW = 
				(PROC_TextOut) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.DLL", "TextOutW");
		}

		// ExtTextOutA
		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.DLL", "ExtTextOutA", CUtil::NewExtTextOutA ) )
		{
			m_sTextFunc.pfnExtTextOutA = 
				(PROC_ExtTextOut) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.DLL", "ExtTextOutA");
		}

		// ExtTextOutW
		if( m_sContainerFunc.pfnHookDllFunction( "GDI32.DLL", "ExtTextOutW", CUtil::NewExtTextOutW ) )
		{
			m_sTextFunc.pfnExtTextOutW = 
				(PROC_ExtTextOut) m_sContainerFunc.pfnGetOrigDllFunction("GDI32.DLL", "ExtTextOutW");
		}

		// DrawTextA
		if( m_sContainerFunc.pfnHookDllFunction( "USER32.DLL", "DrawTextA", CUtil::NewDrawTextA ) )
		{
			m_sTextFunc.pfnDrawTextA = 
				(PROC_DrawText) m_sContainerFunc.pfnGetOrigDllFunction("USER32.DLL", "DrawTextA");
		}

		// DrawTextW
		if( m_sContainerFunc.pfnHookDllFunction( "USER32.DLL", "DrawTextW", CUtil::NewDrawTextW ) )
		{
			m_sTextFunc.pfnDrawTextW = 
				(PROC_DrawText) m_sContainerFunc.pfnGetOrigDllFunction("USER32.DLL", "DrawTextW");
		}

		// DrawTextExA
		if( m_sContainerFunc.pfnHookDllFunction( "USER32.DLL", "DrawTextExA", CUtil::NewDrawTextExA ) )
		{
			m_sTextFunc.pfnDrawTextExA = 
				(PROC_DrawTextEx) m_sContainerFunc.pfnGetOrigDllFunction("USER32.DLL", "DrawTextExA");
		}

		// DrawTextExW
		if( m_sContainerFunc.pfnHookDllFunction( "USER32.DLL", "DrawTextExW", CUtil::NewDrawTextExW ) )
		{
			m_sTextFunc.pfnDrawTextExW = 
				(PROC_DrawTextEx) m_sContainerFunc.pfnGetOrigDllFunction("USER32.DLL", "DrawTextExW");
		}

		// ÷  Լ
		m_sTextFunc.pfnOrigMultiByteToWideChar =
			(PROC_MultiByteToWideChar) CRegistryMgr::RegReadDWORD(_T("HKEY_CURRENT_USER\\Software\\AralGood"), _T("M2WAddr"));

		m_sTextFunc.pfnOrigWideCharToMultiByte =
			(PROC_WideCharToMultiByte) CRegistryMgr::RegReadDWORD(_T("HKEY_CURRENT_USER\\Software\\AralGood"), _T("W2MAddr"));
		
		return true;
	}

	bool CSCMain::_UnhookLibraryFunction()
	{
		if( m_sContainerFunc.pfnUnhookDllFunction == NULL ) return false;
		// LoadLibrary 
		if( m_sLibraryFunc.pfnLoadLibraryA != NULL )
		{
			TRACE(_T("kernel32.DLL!LoadLibraryA Unhook... \n"));
			m_sContainerFunc.pfnUnhookDllFunction( "kernel32.dll", "LoadLibraryA" );
			m_sLibraryFunc.pfnLoadLibraryA = NULL;
		}

		if( m_sLibraryFunc.pfnLoadLibraryW != NULL )
		{
			TRACE(_T("kernel32.DLL!LoadLibraryW Unhook... \n"));
			m_sContainerFunc.pfnUnhookDllFunction( "kernel32.dll", "LoadLibraryW" );
			m_sLibraryFunc.pfnLoadLibraryW = NULL;
		}	
		return true;
	}

	bool CSCMain::_UnhookTextFunction()
	{
		if( m_sContainerFunc.pfnUnhookDllFunction == NULL ) return false;
		// GetGlyphOutlineA 
		if( m_sTextFunc.pfnGetGlyphOutlineA )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.DLL", "GetGlyphOutlineA" );
			m_sTextFunc.pfnGetGlyphOutlineA = NULL;
		}

		// GetGlyphOutlineW 
		if( m_sTextFunc.pfnGetGlyphOutlineW )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.DLL", "GetGlyphOutlineW" );
			m_sTextFunc.pfnGetGlyphOutlineW = NULL;
		}

		// TextOutA 
		if( m_sTextFunc.pfnTextOutA )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.DLL", "TextOutA" );
			m_sTextFunc.pfnTextOutA = NULL;
		}

		// TextOutW 
		if( m_sTextFunc.pfnTextOutW )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.DLL", "TextOutW" );
			m_sTextFunc.pfnTextOutW = NULL;
		}

		// ExtTextOutA 
		if( m_sTextFunc.pfnExtTextOutA )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.DLL", "ExtTextOutA" );
			m_sTextFunc.pfnExtTextOutA = NULL;
		}

		// ExtTextOutW 
		if( m_sTextFunc.pfnExtTextOutW )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.DLL", "ExtTextOutW" );
			m_sTextFunc.pfnExtTextOutW = NULL;
		}

		// DrawTextA 
		if( m_sTextFunc.pfnDrawTextA )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "USER32.DLL", "DrawTextA" );
			m_sTextFunc.pfnDrawTextA = NULL;
		}

		// DrawTextW 
		if( m_sTextFunc.pfnDrawTextW )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "USER32.DLL", "DrawTextW" );
			m_sTextFunc.pfnDrawTextW = NULL;
		}

		// DrawTextExA 
		if( m_sTextFunc.pfnDrawTextExA )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "USER32.DLL", "DrawTextExA" );
			m_sTextFunc.pfnDrawTextExA = NULL;
		}

		// DrawTextExW 
		if( m_sTextFunc.pfnDrawTextExW )
		{
			m_sContainerFunc.pfnUnhookDllFunction( "USER32.DLL", "DrawTextExW" );
			m_sTextFunc.pfnDrawTextExW = NULL;
		}

		ZeroMemory(&m_sTextFunc, sizeof(TEXT_FUNCTION_ENTRY));

		return true;
	}

	bool CSCMain::_UnhookFontFunction()
	{
		if( m_sContainerFunc.pfnUnhookDllFunction == NULL ) return false;

		// Ʈ Լ 
		if( m_sFontFunc.pfnCreateFontA )
		{
			TRACE(_T("GDI32.DLL!CreateFontA Unhook... \n"));
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.dll", "CreateFontA" );
			m_sFontFunc.pfnCreateFontA = NULL;
		}
		if( m_sFontFunc.pfnCreateFontW )
		{
			TRACE(_T("GDI32.DLL!CreateFontW Unhook... \n"));
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.dll", "CreateFontW" );
			m_sFontFunc.pfnCreateFontW = NULL;
		}
		if( m_sFontFunc.pfnCreateFontIndirectA )
		{
			TRACE(_T("GDI32.DLL!CreateFontIndirectA Unhook... \n"));
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.dll", "CreateFontIndirectA" );
			m_sFontFunc.pfnCreateFontIndirectA = NULL;
		}
		if( m_sFontFunc.pfnCreateFontIndirectW )
		{
			TRACE(_T("GDI32.DLL!CreateFontIndirectW Unhook... \n"));
			m_sContainerFunc.pfnUnhookDllFunction( "GDI32.dll", "CreateFontIndirectW" );
			m_sFontFunc.pfnCreateFontIndirectW = NULL;
		}

		return true;
	}

	/////////////////////////////////////////////////////////////////
	// 
	void CSCMain::_FontMapClear(CString sNewFontFace)
	{
		if( m_sLastFontFace != sNewFontFace )
		{
			//  Ƴ Ʈ ü 
			for(map<long, HFONT>::iterator iter = m_mapFonts.begin();
				iter != m_mapFonts.end();
				iter++)
			{
				DeleteObject(iter->second);
			}
			m_mapFonts.clear();

			// ο Ʈ ̽ 
			m_sLastFontFace = sNewFontFace;	
		}
	}

	//####################################################################################

	/////////////////////////////////////////////////////////////////
	// ŷ 巹 ߰. (ϰ:߰ 巹Ÿ ּ)
	CHookAddressData* CSCMain::InsertHookAddress(CHookAddressData* pHookAddress)
	{
		if( pHookAddress == NULL ) return false;


		CHookAddressData* pSearchAddress = SearchHookAddressData(pHookAddress->GetHookModuleAndAddressString());

		if( pSearchAddress != NULL )	// Ȥ  ּҷ ϵ ŷ Ʈ 
		{
			if( pSearchAddress->AddHookRegisterDataFromAddressData(pHookAddress) == true )
			{
				_ChangeHookData();
			}
			return pSearchAddress;
		}
		else
		{
			// ߰
			m_lsHookAddressList.push_back(pHookAddress);
			_ChangeHookData();
			return pHookAddress;
		}


		return NULL;
	}

	////////////////////////////////////////////////////////////////
	// ־ ּҷ ŷ巹 ͸ ã´.
	CHookAddressData* CSCMain::SearchHookAddressData(CString sHookAddress)
	{
		list<CHookAddressData*>::iterator iter_phkaddlist;
		iter_phkaddlist = m_lsHookAddressList.begin();

		while( iter_phkaddlist != m_lsHookAddressList.end() )
		{
			if( (*iter_phkaddlist)->GetHookModuleAndAddressString() == sHookAddress )
			{
				return (*iter_phkaddlist);
			}

			iter_phkaddlist ++;
		}
		return NULL;
	}

	// Ʈ ðԼ
	bool CSCMain::SetFontData(CString sFontFace,long nFontSize)
	{
		// Ʈ ̽
		m_sFontFace = sFontFace;
		m_nFontSize = nFontSize;
		_FontMapClear(m_sFontFace);

		return true;
	}

	bool CSCMain::SetFontData(CString sFontFace,long nFontSize,bool bFixedFontSize)
	{
		SetFontData(sFontFace,nFontSize);
		SetFontState(bFixedFontSize);
		return true;
	}

	bool CSCMain::SetFontData(LOGFONT logfont)
	{
		return SetFontData(logfont.lfFaceName,logfont.lfHeight);
	}

	bool CSCMain::SetFontState(bool bFixedFontSize)
	{
		m_bFixedFontSize = bFixedFontSize;
		return true;
	}

	bool CSCMain::SetEncodeKorean(bool bEncodeKorean)
	{
		m_bEncodeKorean = bEncodeKorean;
		return true;
	}

	bool CSCMain::SetFontLoadLevel(int nLevel)
	{
		m_nFontLoadLevel = nLevel;
		return true;
	}

	// ƮԼ
	CString CSCMain::GetFontFace()
	{
		return m_sFontFace;
	}

	long CSCMain::GetFontSize()
	{
		return m_nFontSize;
	}

	bool CSCMain::IsUseFixedFontSize()
	{
		return m_bFixedFontSize;
	}

	bool CSCMain::IsUseEncodeKorean()
	{
		return m_bEncodeKorean;
	}

	LOGFONT CSCMain::GetFontData()
	{
		LOGFONT logfont;
		ZeroMemory(&logfont, sizeof(LOGFONT));

		if( m_sFontFace != "" ) 
		{
			_tcscpy(logfont.lfFaceName, m_sFontFace);
			logfont.lfHeight = m_nFontSize;
		}
		return logfont;
	}

	int CSCMain::GetFontLoadLevel()
	{
		return m_nFontLoadLevel;
	}

	//############################################################################
	// HookCode ԼԴϴ.

	////////////////////////////////////////////////////
	// HookCode Ÿκ ´.
	CString CSCMain::GetHookOptionString()
	{
		CString sOptionString = _T("");


		sOptionString = _GetHookAddressDataToString();
		// ׿ܿɼ 
		CString sBaseOption = _GetBaseOptionToString();
		if( sBaseOption != "" )
		{
			if( sOptionString != "" )
			{
				sOptionString += ",";
			}
			sOptionString += sBaseOption;
		}
		

		return sOptionString;
	}

	////////////////////////////////////////////////////
	// HookCode Ÿ Ѵ.
	bool CSCMain::SetHookOptionString(CString sOptionString)
	{
		//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		// ⵵Ұ̴ϴ.
		//   κ Ʋ ϴºκԴϴ.
		//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		
		
		if( _SetHookAddressListDataFromString(sOptionString) == false )
		{
			return false;	
		}
		if( _SetBaseOptionFromString(sOptionString) == false)
		{
			return false;
		}

		return true;
	}

	////////////////////////////////////////////////////
	// HookAddressData  HookCode.
	CString CSCMain::_GetHookAddressDataToString()
	{
		// 
		CString sOptionString = _T("");
		for( list<CHookAddressData*>::iterator iter_pHKAddcur = m_lsHookAddressList.begin() ;
			iter_pHKAddcur != m_lsHookAddressList.end();
			iter_pHKAddcur++ )											//
		{
			CString sAddString = (*iter_pHKAddcur)->GetDataToString();
			if( sAddString != _T("") )			// ̹  Ʋ ִٸ.
			{
				if( sOptionString != _T("") )	// ̹  Ʋ ִٸ
				{
					sOptionString += _T(",");	//  ȣ ÷ϰ
				}
				sOptionString += sAddString;	// ̹  ڿ ߰Ѵ.
			}
		}

		return sOptionString;
	}

	// ⺻ ɼ HookCode .
	CString CSCMain::_GetBaseOptionToString()
	{
		CString sOptionString;
		sOptionString = "";
		if( IsUseEncodeKorean() == true )
		{
			if( sOptionString != "" )
			{
				sOptionString += ",";
			}
			sOptionString += CUtil::GetCodeStringFromOption(EHookOptionValue::EncodeKorean);
		}
		if( IsUseFixedFontSize() == true )
		{
			if( sOptionString != "" )
			{
				sOptionString += ",";
			}
			sOptionString += CUtil::GetCodeStringFromOption(EHookOptionValue::FixedFontSize);
		}
		if( GetFontFace() != "" )
		{
			if( sOptionString != "" )
			{
				sOptionString += ",";
			}
			sOptionString += CUtil::GetCodeStringFromOption(EHookOptionValue::FontData);
			
			CString sFontString;
			sFontString.Format(_T("(%s,%d)"),GetFontFace(),GetFontSize());
			
			sOptionString += sFontString;
		}
		
		if( GetFontLoadLevel() > 0 )
		{
			if( sOptionString != "" )
			{
				sOptionString += ",";
			}
			sOptionString += CUtil::GetCodeStringFromOption(EHookOptionValue::FontLoadLevel);
			
			CString sFontString;
			sFontString.Format(_T("(%d)"),GetFontLoadLevel());
			
			sOptionString += sFontString;		
		}

		return sOptionString;
	}

	/////////////////////////////////////////////////////
	// String HookAddress Ѵ.
	bool CSCMain::_SetHookAddressListDataFromString(CString& sOption)
	{
		CString sBufString = sOption;
		
		int nHookAddCount = 0;

		while( sBufString != _T("") ) 
		{
			
			// HookAddress ߰
			CHookAddressData *pNewAdd = new CHookAddressData();
			if( pNewAdd->SettingAddressData(sBufString) == false )
			{
				delete pNewAdd;
				pNewAdd = NULL;
				break;
			}
			if( InsertHookAddress(pNewAdd) == false )
			{
				delete pNewAdd;
				pNewAdd = NULL;
			}
			else
				nHookAddCount ++;
		}

		if( nHookAddCount <= 0 ) return false;

		sOption = sBufString;
		return true;
	}

	////////////////////////////////////////////////////
	// String ⺻ɼ մϴ.
	bool CSCMain::_SetBaseOptionFromString(CString& sOption)
	{
		CString sBufString = sOption;
		CString sLeftString;
		CString sExtractOptionString;

		sLeftString = "";
		sExtractOptionString = "";

		// ѱ -> Ϻ ȯ 
		CString sFindOptionString = CUtil::GetCodeStringFromOption(EHookOptionValue::EncodeKorean);
		if( CUtil::ExtractString(sBufString,sFindOptionString,sLeftString) == true )
		{
			SetEncodeKorean(true);
			sBufString = sLeftString;
			sLeftString = "";
		}
/*Ʈ */
		// Ʈũ 
//		sFindOptionString = CUtil::GetCodeStringFromOption(EHookOptionValue::FixedFontSize);
//		if( CUtil::ExtractString(sBufString,sFindOptionString,sLeftString) == true )
//		{
//			SetFontState(true);
//			sBufString = sLeftString;
//			sLeftString = "";
//		}

		// Ʈ̽ũ 
		sFindOptionString = CUtil::GetCodeStringFromOption(EHookOptionValue::FontData);
		if( CUtil::ExtractString(sBufString,sFindOptionString,sExtractOptionString,sLeftString) == true )
		{
			CString sFontName;
			int nSize;
			int nIndex = sExtractOptionString.Find(_T(","));
	
			sFontName = sExtractOptionString.Left(nIndex);
			nSize = CUtil::atoi2(sExtractOptionString.Mid(nIndex+1,sExtractOptionString.GetLength()-1));
			SetFontData(sFontName,nSize);

			sBufString = sLeftString;
			sLeftString = "";


		}

		// Ʈε巹 
		sFindOptionString = CUtil::GetCodeStringFromOption(EHookOptionValue::FontLoadLevel);
		if( CUtil::ExtractString(sBufString,sFindOptionString,sExtractOptionString,sLeftString) == true )
		{
			
			int nLevel = CUtil::atoi2(sExtractOptionString);
			if( nLevel > 0 )
			{
				SetFontLoadLevel(nLevel);
			}
			sBufString = sLeftString;
			sLeftString = "";
		}
/*Ʈ Ϸ*/
		return true;
	}

	//############################################################################
	// 

	////////////////////////////////////////////////////
	//  ͸   ʴ´.
	bool CSCMain::ClearAllAddressListAndNoDelete()
	{
		m_lsHookAddressList.clear();
		return false;
	}

	////////////////////////////////////////////////////
	//  ͸  Ѵ.
	bool CSCMain::ClearAllAddressListAndDelete()
	{
		while(true)
		{
			if( m_lsHookAddressList.size() == 0 ) return true;			// µ ?
			CHookAddressData* pRegData = m_lsHookAddressList.front();		
			if( pRegData == NULL )									//  
			{
				break;
			}
			// ؾ
			
			m_lsHookAddressList.remove(pRegData);					// Ʈ ϰ	
			delete pRegData;										// ޸𸮿 .
		}
		if( m_lsHookAddressList.size() > 0 ) return false;			// µ ?
		else return true;
	}

	//////////////////////////////////////////////////////////////////////////
	// ŷƮ   ͸ .
	bool CSCMain::ClearFontDataArea()
	{
		m_nFontLoadLevel = 0;				// Ʈ  ε 
		m_nFontSize = 0;					// Ʈ 
		m_sFontFace = "";					// Ʈ
		m_bFixedFontSize = false;				// Ʈ  
		m_bEncodeKorean = false;				// ѱ Ϻ ȯ

		return true;
	}

	//////////////////////////////////////////////////////////////////////////
	// ŷ Ѱ  .
	bool CSCMain::ClearAllHookData()
	{
		ClearAllAddressListAndDelete();
		ClearFontDataArea();

		return true;
	}


	//############################################################################


	//////////////////////////////////////////////////////////////////////////
	// Ͱ ٲ Ÿ.(UpdateHookDataķ)
	bool CSCMain::IsChangeHookData()
	{
		return m_bChangeHookData;
	}

	//////////////////////////////////////////////////////////////////////////
	// Ͽ ٽ false Ͻÿ°
	void CSCMain::UpdateHookData()
	{
		m_bChangeHookData = false;
	}

	//////////////////////////////////////////////////////////////////////////
	// Ÿ ٲ ǥ.
	void CSCMain::_ChangeHookData()
	{
		m_bChangeHookData = true;
	}

	//############################################################################

	//////////////////////////////////////////////////////////////////////////
	// ƮƮ ĿŸ ä
	bool CSCMain::ApplyListControlFromHookData(CListCtrl &lsctlHookAddressList)
	{
		//MessageBox(NULL,_T("ListCtl Apply Start"),_T("CSCMain"),MB_OK);
		lsctlHookAddressList.DeleteAllItems();

		int nRowNumber = 0;
		for( list<CHookAddressData*>::iterator iter_phkAddcur = m_lsHookAddressList.begin();
			iter_phkAddcur != m_lsHookAddressList.end();
			iter_phkAddcur++)
		{
			bool bRes =  (*iter_phkAddcur)->ApplyListControlFromHookData(nRowNumber,lsctlHookAddressList);

			if( bRes == false )
			{
				MessageBox(NULL,_T("HookAddressData ƮƮѿ ִµ Ͽϴ."),_T("CSCMain"),MB_OK);
	//			MessageBox(_T("HookAddressData ƮƮѿ ִµ Ͽϴ."));
			}
		}

		return false;
	}


	//####################################################################################

	//////////////////////////////////////////////////////////////////////////
	//
	int CSCMain::GetAllLoadedModules( PMODULEENTRY32 pRetBuf, int maxCnt )
	{
		int curCnt = 0;

		// ȯ  ʱȭ
		ZeroMemory(pRetBuf, sizeof(PMODULEENTRY32)*maxCnt);
		
		// μ  ڵ 
		HANDLE hModuleSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, GetCurrentProcessId());
		if(INVALID_HANDLE_VALUE == hModuleSnap) return 0;

		pRetBuf[curCnt].dwSize = sizeof(MODULEENTRY32);
		BOOL bExist = Module32First(hModuleSnap, &pRetBuf[curCnt]);

		while( bExist == TRUE && curCnt < maxCnt )
		{
			curCnt++;
			pRetBuf[curCnt].dwSize = sizeof(MODULEENTRY32);
			bExist = Module32Next(hModuleSnap, &pRetBuf[curCnt]);
		}

		CloseHandle (hModuleSnap);

		return curCnt;
	}

	//////////////////////////////////////////////////////////////////////////
	//
	void CSCMain::HookCodeCallback(LPVOID pHookedPoint, PREGISTER_ENTRY pRegisters)
	{
		CSCMain* pInst = CSCMain::GetInstance();
		if( pInst == NULL ) return;

		pInst->Hooking(	(UINT_PTR)pHookedPoint , pRegisters );
	}
}