#pragma once

#ifndef ___SC_MAIN_H___
#define ___SC_MAIN_H___

#include "DefATContainer.h"
#include <Tlhelp32.h>
#include <list>
#include <map>

using namespace std;
//using namespace SCHook;

#include "HookAddressData.h"

class CUtil;

namespace SCHook
{
	class CSCMain
	{
		friend class CUtil;
		//------------------------------------------------------
	protected:
		static CSCMain* ms_pInstance;								// νϽ

	public:
		static bool InitInstance();									// νϽ ʱȭ
		static CSCMain* GetInstance();								// νϽ 
		static bool CloseInstance();								// νϽ 
		//-------------------------------------------------------

	protected:
		CSCMain(void);
	public:
		~CSCMain(void);


		//-------------------------------------------------------
		//
	protected:
		HWND						m_hParentWnd;					// θ handle
		HMODULE						m_hContainer;					// "ATCTNR.DLL"
		CONTAINER_FUNCTION_ENTRY	m_sContainerFunc;				// ŷ Լ ִ ƮƮԴϴ.

		TEXT_FUNCTION_ENTRY			m_sTextFunc;					// ؽƮ  Լ Դϴ.
		FONT_FUNCTION_ENTRY			m_sFontFunc;
		LIBRARY_FUNCTION_ENTRY		m_sLibraryFunc;

		LPSTR						m_szOptionString;				// ؽƮ
		bool						m_bRunning;											


	public:
		// plugin ⺻ ԼԴϴ.
		BOOL Init(HWND hSettingWnd, LPSTR cszOptionStringBuffer);	// ÷ ʱȭ
		BOOL Close();												// ÷ 
		BOOL Start();												// ÷ 
		BOOL Stop();												// ÷ 
		BOOL Option();												// ÷ ɼâ 

		// 

		// ŷԼ
		bool StartHooking();										// ŷ 
		bool EndHooking();											// ŷ 
		bool HookCodePoint(UINT_PTR pCodePoint);					// ŷ Ѵ.
		bool UnhookCodePoint(UINT_PTR pCodePoint);					// ũѴ.
		bool Hooking(UINT_PTR pHookedPoint, PREGISTER_ENTRY pRegisters);
																	// ŷǾ.

		bool TranslateText(LPCSTR cszJapanese, LPSTR szKorean, int nBufSize);
																	// Ѵ.

		bool IsRunningHooker();										// Ŀ  Ÿ.

		//===========================================================
		//  
	protected:
		map<long, HFONT>			m_mapFonts;
		CString						m_sLastFontFace;

	public:
		HFONT CheckFont( HDC hdc );

	protected:
		bool _InitContanerFunction();
		bool _InitFontFunction();
		bool _InitLibraryFunction();
		bool _InitTextFunction();
		bool _UnhookLibraryFunction();
		bool _UnhookTextFunction();
		bool _UnhookFontFunction();

		void _FontMapClear(CString sNewFontFace = _T(""));

		//===========================================================
		// Ŀ 
	protected:
		list<CHookAddressData*>		m_lsHookAddressList;			// ŷϴ 巹 Ʈ
		bool						m_bAllHookingSuccess;			//  ŷ ߴ մϴ.
		bool						m_bChangeHookData;				// ŷϴ Ÿ  ŵǾ Ÿ.

		

		int							m_nFontLoadLevel;				// Ʈ  ε 
		long						m_nFontSize;					// Ʈ 
		CString						m_sFontFace;					// Ʈ
		
		bool						m_bFixedFontSize;				// Ʈ  
		bool						m_bEncodeKorean;				// ѱ Ϻ ȯ

	public:
		//-------------------------
		// ð  Լ

		CHookAddressData* InsertHookAddress(CHookAddressData* pHookAddress);
																	// ŷ 巹 ߰.(ϰ:߰ 巹Ÿ ּ)
		CHookAddressData* SearchHookAddressData(CString sHookAddress);
																	// ־ ּҷ ŷ巹 ͸ ã´.
		
		// 
		bool ClearAllAddressListAndNoDelete();						//  ͸   ʴ´.
		bool ClearAllAddressListAndDelete();						//  ͸  Ѵ.
		bool ClearFontDataArea();
		bool ClearAllHookData();


		// Ʈ ðԼ
		bool SetFontData(CString sFontFace,long nFontSize);
		bool SetFontData(CString sFontFace,long nFontSize,bool bFixedFontSize);
		bool SetFontData(LOGFONT logfont);
		bool SetFontState(bool bFixedFontSize);
		bool SetEncodeKorean(bool bEncodeKorean);
		bool SetFontLoadLevel(int nLevel);

		// ƮԼ
		CString GetFontFace();
		long GetFontSize();
		bool IsUseFixedFontSize();
		bool IsUseEncodeKorean();
		LOGFONT GetFontData();	
		int GetFontLoadLevel();

		// ŷڵ 
		CString GetHookOptionString();								// HookCode Ÿκ ´.
		bool SetHookOptionString(CString sOptionString);			// HookCode Ÿ Ѵ.

		//   ǥ
		bool IsChangeHookData();									// Ͱ ٲ Ÿ.(UpdateHookDataķ)
		void UpdateHookData();										// Ͽ ٽ false Ͻÿ°
	protected:
		CString _GetHookAddressDataToString();						// HookAddressData  HookCode.
		bool _SetHookAddressListDataFromString(CString& sOption);	// String HookAddress Ѵ.

		CString _GetBaseOptionToString();							// ⺻ ɼ HookCode .
		bool _SetBaseOptionFromString(CString& sOption);			// String ⺻ɼ մϴ.

		void _ChangeHookData();										// Ÿ ٲ ǥ.

		

		//------------------------------------------------------
		// ŷ 
	public:
		bool ApplyListControlFromHookData(CListCtrl &lsctlHookAddressList);	// ƮƮ ĿŸ ä



		//-------------------------------------------------------
		//  ԼԴϴ.
	public:
		static int GetAllLoadedModules(PMODULEENTRY32 pRetBuf, int maxCnt);

		//
		static void HookCodeCallback(LPVOID pHookedPoint, PREGISTER_ENTRY pRegisters);
	};
}

#endif